<?php

if (!isset($GLOBALS["m23_language"]))
	$GLOBALS['m23_language'] = 'de';

include('/m23/inc/checks.php');
include('/m23/inc/db.php');
include('/m23/inc/fdisk.php');
include_once('/m23/inc/html.php');
include('/m23/inc/remotevar.php');
include('/m23/inc/client.php');
include("/m23/inc/backup.php");
include('/m23/inc/message.php');
include_once('/m23/inc/CMessageManager.php');
include('/m23/inc/distr.php');
include("/m23/inc/preferences.php");
include('/m23/inc/sourceslist.php');
include_once('/m23/inc/messageReceive.php');
include('/m23/inc/packages.php');
include_once('/m23/inc/capture.php');
include_once('/m23/inc/helper.php');
include_once('/m23/inc/update.php');
include_once('/m23/inc/edit.php');
include_once('/m23/inc/dhcp.php');
include_once('/m23/inc/ldap.php');
include_once('/m23/inc/assimilate.php');
include_once('/m23/inc/i18n.php');
include_once('/m23/inc/server.php');
include_once('/m23/inc/raidlvm.php');
include_once("/m23/inc/halfSister.php");
include_once('/m23/inc/vm.php');
include_once('/m23/inc/groups.php');
include_once('/m23/inc/CMessageManager.php');
include_once('/m23/inc/CChecks.php');
include_once('/m23/inc/CClient.php');
include_once('/m23/inc/CIPRanges.php');
include_once('/m23/inc/CClientLister.php');
include_once('/m23/inc/Cm23Admin.php');
include_once('/m23/inc/Cm23AdminLister.php');
include_once('/m23/inc/CFDiskIO.php');
include_once('/m23/inc/CFDiskBasic.php');
include_once('/m23/inc/mail.php');
include_once('/m23/inc/CGPGSign.php');
include_once('/m23/inc/packageBuilder.php');
include_once('/m23/inc/CFreeIPA.php');
include_once('/m23/inc/CFreeIPAUser.php');
include_once('/m23/inc/CSchoolFreeIPA.php');
include_once('/m23/inc/CSchool.php');
include_once('/m23/inc/CSchoolManagement.php');
include_once('/m23/inc/CDDP.php');
include_once('/m23/inc/massTools.php');
include_once('/m23/inc/CLibreWorkspace.php');
include_once('/m23/inc/CSystemProxy.php');


/*

# Installation eines neuen Rechners

# - m23-Join eines bestehenden Rechners
# - Rausnehmen eines Rechners aus der Verwaltung

#- Übersicht der vorhandenen Clients, Auswählbar nach Gruppen oder Alle
- Verwaltung in Gruppen

# - Paket suchen


- Entfernen/Installieren von Software
#	- APT
	- Snap
	- Flatpak

Spezialpakete
	- Ausführen eines Bash-Scripts
	- Neustart/Herunterfahren
		PKG_addShutdownPackage($client)
	- Setzen eines StandardHintergrundbildes
	- Deaktivieren/Aktiveren von openssh-server des Clients, Hinzufügen eines SSH-Schlüssels vom Nutzer definiert

- Aktualisierung (täglich? automatisch)

- Dashboard über den aktuellen Client-Status

Steuerung vom Portal aus über die Kommando-Zeile/http api wäre auch cool

*/

dbConnect();







// Check, if parameters are given via GET
if ($_SERVER['REQUEST_METHOD'] != 'GET') die('Error: Invalid method!');

// Check, if a command is given
if (!isset($_GET['cmd'])) die('Error: No command specified');

// Read API key
if (!file_exists('/m23/etc/apiKey')) die('Error: /m23/etc/apiKey not found!');
if (!is_readable('/m23/etc/apiKey')) die('Error: /m23/etc/apiKey is not readable!');
$apiKey = trim(file_get_contents('/m23/etc/apiKey'));


// Check, if the API key is provided and matches
if (!isset($_GET['api_key']) || $_GET['api_key'] != $apiKey) die('Error: Invalid or missing API key');

// Set the output to JSON
header('Content-Type: application/json');

	switch ($_GET['cmd'])
	{
		/*
			TEST: http://localhost/rest.php?api_key=HY3R8rOC4sadFxvS9ucwAGZNP71oWJV0&cmd=getClientList&group=default
			TEST: http://localhost/rest.php?api_key=HY3R8rOC4sadFxvS9ucwAGZNP71oWJV0&cmd=getClientList
			example: ["aTlocalbookwormdebMatex64de","aTlocalbullseyedebCinnamonFullx64de","aTlocalJammyLubuntux64fr","aTlocalLM21VanessaCinnamonx64fr"]

			RESULT: ok
		*/

		case 'getClientList':

			/**
			**description Lists names of all clients or clients that belong to a group
			**url rest.php?api_key=[key]&cmd=getClientList&group=[groupname]
			**parameter group: Optionally set a group name. Invalid group name will give out all clients.
			**/

			$CClientListerO = new CClientLister;

			// Add a group filter (if set)
			if (isset($_GET['group']))
				$CClientListerO->addGroupFilter($_GET['group']);
			
			// Convert the array to JSON and output it
			echo(json_encode($CClientListerO->getClientNames()));
		break;





		/*
			TEST: http://localhost/rest.php?api_key=HY3R8rOC4sadFxvS9ucwAGZNP71oWJV0&cmd=getProfiles
			example: ["Debian 12 KDE"]

			RESULT: ok
		*/

		case 'getProfiles':

			/**
			**description Lists names of all clients or clients that belong to a group
			**url rest.php?api_key=[key]&cmd=getProfiles
			**/

			$CDDPO = new CDDP;
			echo(json_encode($CDDPO->getProfiles()));
		break;





		/*
			TEST: http://localhost/rest.php?api_key=HY3R8rOC4sadFxvS9ucwAGZNP71oWJV0&cmd=getNetworkSettingsProposal
			example: {"ip":"192.168.1.15","netmask":"255.255.255.0","gateway":"192.168.1.5","dns1":"192.168.1.5","dns2":"8.8.8.8","bootTypes":{"pxe":"pxe","grub2EFIx64":"UEFI x86_64","gpxe":"gPXE\/DHCP"}}
			RESULT: ok

			script example: /mdk/LW-Addon/REST-Test/getNetworkSettingsProposal.py
		*/

		case 'getNetworkSettingsProposal':

			/**
			**description Gives out precalculated network settings (eg. next free IP that can be uses for an m23 client).
			**url rest.php?api_key=[key]&cmd=getNetworkSettingsProposal
			**/

			$proposedNetworkSettings = array();
			$proposedNetworkSettings['ip'] = CLIENT_getNextFreeIp();
			$proposedNetworkSettings['netmask'] = getServerNetmask();
			$proposedNetworkSettings['gateway'] = getServerGateway();

			$dns1dns2 = getDNSServers();
			$proposedNetworkSettings['dns1'] = $dns1dns2[0];
			$proposedNetworkSettings['dns2'] = $dns1dns2[1];

			$proposedNetworkSettings['bootTypes'] = CClient::getNetworkBootTypesArrayForSelection();
			echo(json_encode($proposedNetworkSettings));
		break;





		/*
			TEST: http://localhost/rest.php?api_key=HY3R8rOC4sadFxvS9ucwAGZNP71oWJV0&cmd=addClient&client=apiclient&ip=192.168.1.141&netmask=255.255.255.0&gateway=192.168.1.5&dns1=192.168.1.5&dns2=192.168.1.5&mac=001122334455&boottype=pxe&login=test&password=test&rootpassword=test&profile=Debian+12+KDE
			TEST: http://localhost/rest.php?api_key=HY3R8rOC4sadFxvS9ucwAGZNP71oWJV0&cmd=addClient&client=apiclient&ip=192.168.1.141&netmask=255.255.255.0&gateway=192.168.1.5&dns1=192.168.1.5&dns2=192.168.1.5&mac=080027765C42&boottype=pxe&login=test&password=test&rootpassword=test&profile=Debian+12+KDE

			RESULT: ok
		*/

		case 'addClient':

			/**
			**description Gives out precalculated network settings (eg. next free IP that can be uses for an m23 client).
			**url rest.php?api_key=[key]&cmd=addClient&client=[client]&ip=[ip]&netmask=[netmask]&gateway=[gateway]&dns1=[dns1]&dns2=[dns2]&mac=[mac]&boottype=[boottype]&login=[login]&password=[password]&rootpassword=[rootpassword]&profile=[profile]
			**parameter client: client name
			**parameter ip: IP of the client
			**parameter netmask: netmask of the client
			**parameter gateway: gateway of the client
			**parameter dns1: DNS server 1
			**parameter dns2: DNS server 2
			**parameter mac: client MAC
			**parameter boottype: network boot type
			**parameter login: name of the user
			**parameter password: password for the user
			**parameter rootpassword: root password
			**parameter profile: Name of the distribution/desktop profile.
			**/

			$installParams = array();
			$err = '';

			// Check for required parameters
			if (HELPER_checkRESTParameter(array('client', 'ip', 'netmask', 'gateway', 'dns1', 'dns2', 'mac', 'boottype', 'login', 'password', 'rootpassword', 'profile')))
			{
				$installParams['client'] = $_GET['client'];
				$installParams['ip'] = $_GET['ip'];
				$installParams['netmask'] = $_GET['netmask'];
				$installParams['gateway'] = $_GET['gateway'];
				$installParams['dns1'] = $_GET['dns1'];
				$installParams['dns2'] = $_GET['dns2'];
				$installParams['mac'] = $_GET['mac'];
				$installParams['dhcpBootimage'] = $_GET['boottype'];
				$installParams['name'] = $installOptions['login'] = $_GET['login'];
				$installParams['firstpw'] = $_GET['password'];
				$installParams['rootpassword'] = $_GET['rootpassword'];
				// Set required values to blank
				$installParams['familyname'] = $installParams['office'] = '';

				$returnCode = CLIENT_installClientViaProfile($_GET['profile'], $installOptions, $installParams, $err);

				$data = array();	
				echo(HELPER_getJSONMessage($data, $returnCode, $err));
			}
			else
			{
				CLIENT_deleteClient($installParams['client']);
				$data = array();
				echo(HELPER_getJSONMessage($data, 1, 'Client could not be added'));
			}
		break;





		/*
			TEST: http://localhost/rest.php?api_key=HY3R8rOC4sadFxvS9ucwAGZNP71oWJV0&cmd=assimilateClient&client=assiclient&ip=192.168.1.141&password=test&ubuntuuser=&clientusesdynamicip=0
		*/

		case 'assimilateClient':

			/**
			**description Adds needed data for assimilating a client.
			**url rest.php?api_key=[key]&cmd=assimilateClient&client=[client]&ip=[ip]&password=[password]&ubuntuuser=[ubuntuuser]&clientusesdynamicip=[clientusesdynamicip]
			**parameter client: name of the client
			**parameter ip: IP of the client
			**parameter password: root password on Debian systems or combines user/root password on Ubuntu systems
			**parameter ubuntuuser: name of the Ubuntu user or empty if a Debian system is meant.
			**parameter clientUsesDynamicIP: if set to 1, the client uses a dynamic IP address
			**/

			$err = '';

			// Check for required parameters
			if (HELPER_checkRESTParameter(array('client', 'ip', 'password', 'ubuntuuser', 'clientusesdynamicip')))
			{
				$returnCode = ASSI_addClient($_GET['client'], $_GET['ip'], $_GET['password'], $_GET['ubuntuuser'], $_GET['clientusesdynamicip'] == 1 ? true : false, false, $err);

				$data = array();
				echo(HELPER_getJSONMessage($data, $returnCode, $err));
			}
		break;





		/*
			TEST: http://localhost/rest.php?api_key=HY3R8rOC4sadFxvS9ucwAGZNP71oWJV0&cmd=deleteClient&client=delclient
		*/

		case 'deleteClient':

			/**
			**description Deletes a client
			**url rest.php?api_key=[key]&cmd=deleteClient&client=[client]
			**parameter client: name of the client
			**/

			// Check for required parameters
			if (HELPER_checkRESTParameter(array('client')))
			{
				$data = array();

				if (CLIENT_exists($_GET['client']))
				{
					CLIENT_deleteClient($_GET['client']);
					echo(HELPER_getJSONMessage($data, 0, ''));
				}
				else
				{
					echo(HELPER_getJSONMessage($data, 1, 'Client "'.$_GET['client'].'" does not exists!'));
				}
			}
		break;





		/*
			TEST: http://localhost/rest.php?api_key=HY3R8rOC4sadFxvS9ucwAGZNP71oWJV0&cmd=searchPackges&client=m23cl-lm21&search=mc
		*/

		case 'searchPackges':

			/**
			**description Get installable packages for a client
			**url rest.php?api_key=[key]&cmd=searchPackges&client=[client]&search=[search]
			**parameter client: name of the client
			**parameter search: Search term
			**/

			// Check for required parameters
			if (HELPER_checkRESTParameter(array('search', 'client')))
			{
				$data = PKG_getInstallablePackages($_GET['search'], $_GET['client']);
				
				if (count($data) > 0)
					echo(HELPER_getJSONMessage($data, 0, ''));
				else
				{
					$data = array();
					echo(HELPER_getJSONMessage($data, 1, 'No packages found for "'.$_GET['search'].'"'));
				}
			}
		break;





		/*
			TEST: http://localhost/rest.php?api_key=HY3R8rOC4sadFxvS9ucwAGZNP71oWJV0&cmd=installPackages&client=apiclient&packages=mc

			RESULT: ok
		*/

		case 'installPackages':

			/**
			**description Installs one or more packages on a client
			**url rest.php?api_key=[key]&cmd=installPackages&client=[client]&packages=[packages]
			**parameter client: Name of the client
			**parameter packages: Name of package(s) (separated by space)
			**/
			
			// Check for required parameters
			if (HELPER_checkRESTParameter(array('client', 'packages')))
			{
				PKG_deOrInstallBunchOfNormalPackages($_GET['client'], 'm23normal', $_GET['packages']);

				$data = array();
				echo(HELPER_getJSONMessage($data, 0, 'Job added'));
			}

		break;





		/*
			TEST: http://localhost/rest.php?api_key=HY3R8rOC4sadFxvS9ucwAGZNP71oWJV0&cmd=deinstallPackages&client=m23cl-lm21&packages=mc

			RESULT: ok
		*/

		case 'deinstallPackages':

			/**
			**description Deinstalls one or more packages from a client
			**url rest.php?api_key=[key]&cmd=deinstallPackages&client=[client]&packages=[packages]
			**parameter client: Name of the client
			**parameter packages: Name of package(s) (separated by space)
			**/
			
			// Check for required parameters
			if (HELPER_checkRESTParameter(array('client', 'packages')))
			{
				PKG_deOrInstallBunchOfNormalPackages($_GET['client'], 'm23normalRemove', $_GET['packages']);

				$data = array();
				echo(HELPER_getJSONMessage($data, 0, 'Job added'));
			}

		break;





		/*
			TEST: http://localhost/rest.php?api_key=HY3R8rOC4sadFxvS9ucwAGZNP71oWJV0&cmd=shutdownClient&client=apiclient

			RESULT: ok
		*/

		case 'shutdownClient':

			/**
			**description Shutdowns a client
			**url rest.php?api_key=[key]&cmd=shutdownClient&client=[client]
			**parameter client: Name of the client
			**/
			
			// Check for required parameters
			if (HELPER_checkRESTParameter(array('client')))
			{
				PKG_addJob($_GET['client'],"m23Shutdown",PKG_getSpecialPackagePriority("m23Shutdown"),"");
				CLIENT_startInstall($_GET['client']);

				$data = array();
				echo(HELPER_getJSONMessage($data, 0, 'Job added'));
			}

		break;





		/*
			TEST: http://localhost/rest.php?api_key=HY3R8rOC4sadFxvS9ucwAGZNP71oWJV0&cmd=rebootClient&client=apiclient

			RESULT: ok
		*/

		case 'rebootClient':

			/**
			**description Reboots a client
			**url rest.php?api_key=[key]&cmd=rebootClient&client=[client]
			**parameter client: Name of the client
			**/
			
			// Check for required parameters
			if (HELPER_checkRESTParameter(array('client')))
			{
				PKG_addJob($_GET['client'],"m23Reboot",PKG_getSpecialPackagePriority("m23Reboot"),"");
				CLIENT_startInstall($_GET['client']);

				$data = array();
				echo(HELPER_getJSONMessage($data, 0, 'Job added'));
			}

		break;





		/*
			TEST: http://localhost/rest.php?api_key=HY3R8rOC4sadFxvS9ucwAGZNP71oWJV0&cmd=clientPackages&client=08cl2&search=&status=all
			TEST: http://localhost/rest.php?api_key=HY3R8rOC4sadFxvS9ucwAGZNP71oWJV0&cmd=clientPackages&client=08cl2&search=&status=installed
			TEST: http://localhost/rest.php?api_key=HY3R8rOC4sadFxvS9ucwAGZNP71oWJV0&cmd=clientPackages&client=apiclient&search=mc&status=installed
			example: {"status":"success","error_code":0,"packages":["mc"],"packageAmount":1}

			RESULT: ok
		*/

		case 'clientPackages':

			/**
			**description Get a list of packages that have a specified status
			**url rest.php?api_key=[key]&cmd=clientPackages&client=[client]&search=[search]&status=[status]
			**parameter client: Name of the client
			**parameter search: Search term or empty for all packages
			**parameter status: The status the packages should have: installed, removed, purged, all
			**/
			
			// Check for required parameters
			if (HELPER_checkRESTParameter(array('client', 'search', 'status')))
			{
				// Check, if a correct status code is given and convert it to the internal status constant
				switch ($_GET['status'])
				{
					case 'installed':
						$status = DEBPKGSTAT_installed;
					break;

					case 'removed':
						$status = DEBPKGSTAT_removed;
					break;

					case 'purged':
						$status = DEBPKGSTAT_purge;
					break;

					case 'all':
						$status = '';
					break;

					default:
						$data = array();
						echo(HELPER_getJSONMessage($data, 1, 'Status "'.$_GET['status'].'" unknown'));
				}

				$data['packages'] = PKG_getClientPackages($_GET['client'], $_GET['search'], true, $status);
				$data['packageAmount'] = count($data['packages']);
				echo(HELPER_getJSONMessage($data, 0, ''));
			}

		break;





		default:
			die('Error: Invalid command!');
	}






?>